<center><a href="ex5fs.F">Actual source code: ex5fs.F</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:31:40+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a>!
<a name="line2">  2: </a>! ---------------------------------------------------------------------
<a name="line3">  3: </a>!
<a name="line4">  4: </a>!  Fortran version of the user function based on shared memory
<a name="line5">  5: </a>!  this routine is called only by MPI process 0 in the computation
<a name="line6">  6: </a>!  but uses threads to run the loops in parallel.

<a name="line8">  8: </a>!
<a name="line9">  9: </a>!  Input Parameter:
<a name="line10"> 10: </a>!  x - global array containing input values
<a name="line11"> 11: </a>!
<a name="line12"> 12: </a>!  Output Parameters:
<a name="line13"> 13: </a>!  f - global array containing output values
<a name="line14"> 14: </a>!  ierr - error code
<a name="line15"> 15: </a>!
<a name="line16"> 16: </a>!  Notes:
<a name="line17"> 17: </a>!  This routine uses standard Fortran-style computations over a 2-dim array.
<a name="line18"> 18: </a>!
<a name="line19"> 19: </a>      subroutine ApplicationFunctionFortran(lambda,mx,my,x,f,ierr)

<a name="line21"> 21: </a>      implicit none

<a name="line23"> 23: </a> #include <A href="../../../../include/finclude/petsc.h.html">include/finclude/petsc.h</A>
<a name="line24"> 24: </a>      integer  ierr,mx,my

<a name="line26"> 26: </a>!  Input/output variables:
<a name="line27"> 27: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>   x(mx,my),f(mx,my),lambda


<a name="line30"> 30: </a>!  Local variables:
<a name="line31"> 31: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>   two,one,hx,hy,hxdhy,hydhx,sc
<a name="line32"> 32: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>   u,uxx,uyy
<a name="line33"> 33: </a>      integer  i,j

<a name="line35"> 35: </a>      one    = 1.0
<a name="line36"> 36: </a>      two    = 2.0
<a name="line37"> 37: </a>      hx     = one/dble(mx-1)
<a name="line38"> 38: </a>      hy     = one/dble(my-1)
<a name="line39"> 39: </a>      sc     = hx*hy*lambda
<a name="line40"> 40: </a>      hxdhy  = hx/hy
<a name="line41"> 41: </a>      hydhx  = hy/hx

<a name="line43"> 43: </a>!  Compute function over the entire grid

<a name="line45"> 45: </a>      <font color="#4169E1">do</font> 20 j=1,my
<a name="line46"> 46: </a>         <font color="#4169E1">do</font> 10 i=1,mx
<a name="line47"> 47: </a>            <font color="#4169E1">if</font> (i .eq. 1 .or. j .eq. 1                                  &amp;
<a name="line48"> 48: </a>     &amp;             .or. i .eq. mx .or. j .eq. my) then
<a name="line49"> 49: </a>               f(i,j) = x(i,j)
<a name="line50"> 50: </a>            <font color="#4169E1">else</font>
<a name="line51"> 51: </a>               u = x(i,j)
<a name="line52"> 52: </a>               uxx = hydhx * (two*u                                     &amp;
<a name="line53"> 53: </a>     &amp;                - x(i-1,j) - x(i+1,j))
<a name="line54"> 54: </a>               uyy = hxdhy * (two*u - x(i,j-1) - x(i,j+1))
<a name="line55"> 55: </a>               f(i,j) = uxx + uyy - sc*exp(u)
<a name="line56"> 56: </a>            endif
<a name="line57"> 57: </a> 10      <font color="#4169E1">continue</font>
<a name="line58"> 58: </a> 20   <font color="#4169E1">continue</font>

<a name="line60"> 60: </a>      <font color="#4169E1">return</font>
<a name="line61"> 61: </a>      end

</pre>
</body>

</html>
